package com.zhongzheng.modules.base.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.zhongzheng.modules.base.bo.CertificateTpAddBo;
import com.zhongzheng.modules.base.bo.CertificateTpEditBo;
import com.zhongzheng.modules.base.bo.CertificateTpQueryBo;
import com.zhongzheng.modules.base.domain.CertificateTp;
import com.zhongzheng.modules.base.vo.CertificateTpVo;
import com.zhongzheng.modules.grade.bo.ClassGradeUserQueryBo;

import java.util.Collection;
import java.util.List;

/**
 * 证书模板Service接口
 *
 * @author hjl
 * @date 2022-02-16
 */
public interface ICertificateTpService extends IService<CertificateTp> {
	/**
	 * 查询单个
	 * @return
	 */
	CertificateTpVo queryById(Long tpId);

	/**
	 * 查询列表
	 */
	List<CertificateTpVo> queryList(CertificateTpQueryBo bo);

	/**
	 * 根据新增业务对象插入证书模板
	 * @param bo 证书模板新增业务对象
	 * @return
	 */
	Boolean insertByAddBo(CertificateTpAddBo bo);

	/**
	 * 根据编辑业务对象修改证书模板
	 * @param bo 证书模板编辑业务对象
	 * @return
	 */
	Boolean updateByEditBo(CertificateTpEditBo bo);

	String makeCertificatePhoto(ClassGradeUserQueryBo bo);

	List<CertificateTpVo> selectList(CertificateTpQueryBo bo);

	/**
	 * 校验并删除数据
	 * @param ids 主键集合
	 * @param isValid 是否校验,true-删除前校验,false-不校验
	 * @return
	 */
	Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);
}
